//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
import { ControlProxy } from "./ControlProxy.js";
export class AbstractControl {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor() {
        this.proxy = new ControlProxy(this);
    }
    describe() {
        throw new Error("Method not implemented.");
    }
    //**********************************************************************
    // Override Methods (Disposable)
    //**********************************************************************
    /**
     * Disposes of this control. This method is called to release resources used
     * by this control, in particular its LiveProperties.
     */
    dispose() {
        this.proxy.dispose();
    }
    //**********************************************************************
    // Override Methods (LivePropertyListener)
    //**********************************************************************
    propertyChanged(e) {
    }
}
//******************************************************************************
//# sourceMappingURL=AbstractControl.js.map