//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
import { printClass } from "./printClass.js";
export class LivePropertyEvent //extends EventObject
 {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    //property:LiveProperty;
    /**
     * Creates an event triggered by a change to the Variable bound to a
     * LiveProperty.
     */
    constructor(property, e) {
        if (printClass.printStatus)
            console.log("Constructor of liveProperty Event");
        //super(property)
        this.property = property;
        if (property && e) {
            this.e = e;
        }
        else {
            this.e = null;
        }
    }
    //**********************************************************************
    // Getters and Setters
    //**********************************************************************
    /**
     * Returns the LiveProperty that generated this event.
     */
    getLiveProperty() {
        return this.property;
    }
    /**
     * Returns the VariableEvent that triggered this event, or <CODE>null</CODE>
     * if this event was triggered by the binding of a new <CODE>Variable</CODE>
     * to a LiveProperty.
     */
    getVariableEvent() {
        return this.e;
    }
}
//******************************************************************************
//# sourceMappingURL=LivePropertyEvent.js.map