//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
import { Prototype } from "../LP/Prototype.js";
import { ControlProxy } from "../LP/ControlProxy.js";
import { VariableEvent } from "../LP/VariableEvent.js";
import { CanvasClass } from "../view/canvas.js";
//import { typeOfValue } from "../index.js";
import { printClass } from "../LP/printClass.js";
//******************************************************************************
// class ControlSlider
//******************************************************************************
export class ControlCanvas {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor(name) {
        //Create Control Proxy
        //**********************************************************************
        // Public Class Members (Properties)
        //**********************************************************************
        this.CTAG_Height = "Height";
        this.CTAG_Width = "Width";
        this.TYPE_Height = new Prototype(Number.prototype, this.CTAG_Height, 0);
        this.TYPE_Width = new Prototype(Number.prototype, this.CTAG_Width, 0);
        this.proxy = new ControlProxy(this);
        //create live property
        this.live_property1 = this.proxy.add(this.CTAG_Height, this.TYPE_Height, true);
        this.live_property2 = this.proxy.add(this.CTAG_Width, this.TYPE_Width, true);
        if (printClass.printStatus)
            console.log(this.live_property1);
        if (printClass.printStatus)
            console.log(this.live_property2);
        this.ControlName = name;
        this.canvas = new CanvasClass(name);
        if (printClass.printStatus)
            console.log(name);
    }
    //**********************************************************************
    // Public Methods (Properties)
    //**********************************************************************
    getHeight() {
        return (this.proxy.getValue(this.CTAG_Height));
    }
    setHeight(value) {
        this.proxy.setValue(this.CTAG_Height, value);
        //this.canvas.setValue(value);
    }
    getWidth() {
        return (this.proxy.getValue(this.CTAG_Width));
    }
    setWidth(value) {
        this.proxy.setValue(this.CTAG_Width, value);
        //this.canvas.setValue(value);
    }
    //**********************************************************************
    // Override Methods (LivePropertyListener)
    //**********************************************************************
    propertyChanged(e) {
        if (printClass.printStatus)
            console.log("propertyChanged method of controlSlider");
        if (printClass.printStatus)
            console.log(e);
        var tag = e.getLiveProperty().getTag();
        if (printClass.printStatus)
            console.log(tag);
        var ve = e.getVariableEvent();
        if (printClass.printStatus)
            console.log(ve); //this value should not be null
        if (printClass.printStatus)
            console.log(ve.getType());
        if (printClass.printStatus)
            console.log(VariableEvent.VALUE_CHANGED);
        if (tag == this.CTAG_Height) {
            if (printClass.printStatus)
                console.log("ControlCanvas height");
            if (printClass.printStatus)
                console.log(e.getLiveProperty().variable.getPrototype().value);
            if (printClass.printStatus)
                console.log(e.getLiveProperty().getVariable().getValue());
            this.canvas.setHeight(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Width) {
            if (printClass.printStatus)
                console.log("ControlCanvas Width");
            if (printClass.printStatus)
                console.log(e.getLiveProperty().variable.getPrototype().value);
            //if (this.slider.getValue() != value)
            if (printClass.printStatus)
                console.log(e.getLiveProperty().getVariable().getValue());
            this.canvas.setWidth(e.getLiveProperty().getVariable().getValue());
        }
    }
    //**********************************************************************
    // Private Methods (Graphics)
    //**********************************************************************
    describe() {
        throw new Error("Method not implemented.");
    }
    dispose() {
        throw new Error("Method not implemented.");
    }
}
//******************************************************************************
//# sourceMappingURL=ControlCanvas.js.map