//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
import { Prototype } from "../LP/Prototype.js";
import { ControlProxy } from "../LP/ControlProxy.js";
//import { typeOfValue } from "../index.js";
import { printClass } from "../LP/printClass.js";
import { GradientClass } from "../view/gradient.js";
//******************************************************************************
// class ControlSlider
//******************************************************************************
export class ControlGradient {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor(name, data, xPos, yPos, horizontal, inputWidth, inputHeight, helper) {
        //**********************************************************************
        // Public Class Members (Properties)
        //**********************************************************************
        this.CTAG_xTranslate = "xTranslate";
        this.CTAG_yTranslate = "yTranslate";
        this.CTAG_Size = "Size";
        this.CTAG_Opacity = "Opacity";
        this.CTAG_Selection = "Selection";
        //public CTAG_Zoom: string = "Zoom"; 
        this.TYPE_xTranslate = new Prototype(Array.prototype, this.CTAG_xTranslate, [null, null]);
        this.TYPE_yTranslate = new Prototype(Array.prototype, this.CTAG_yTranslate, [null, null]);
        this.TYPE_Size = new Prototype(Number.prototype, this.CTAG_Size, 0);
        this.TYPE_Opacity = new Prototype(Number.prototype, this.CTAG_Opacity, 0);
        this.TYPE_Selection = new Prototype(Array.prototype, this.CTAG_Selection, [false]);
        if (printClass.printStatus)
            console.log("I am in constructor of ControlGradient");
        //Create Control Proxy
        //if(printClass.printStatus) console.log(this.TYPE_VALUE);
        this.proxy = new ControlProxy(this);
        //create live property
        this.live_property1 = this.proxy.add(this.CTAG_xTranslate, this.TYPE_xTranslate, true);
        this.live_property2 = this.proxy.add(this.CTAG_yTranslate, this.TYPE_yTranslate, true);
        this.live_property3 = this.proxy.add(this.CTAG_Opacity, this.TYPE_Opacity, true);
        this.live_property4 = this.proxy.add(this.CTAG_Selection, this.TYPE_Selection, true);
        this.live_property5 = this.proxy.add(this.CTAG_Size, this.TYPE_Size, true);
        //this.live_property6 = this.proxy.add(this.CTAG_Zoom, this.TYPE_Zoom, true);              
        if (printClass.printStatus)
            console.log(this.live_property1);
        if (printClass.printStatus)
            console.log(this.live_property2);
        this.ControlName = name;
        this.gradient = new GradientClass(this, name, data, xPos, yPos, horizontal, inputWidth, inputHeight, helper);
        if (printClass.printStatus)
            console.log(name);
    }
    //**********************************************************************
    // Public Methods (Properties)
    //**********************************************************************
    getTranslateX() {
        return this.proxy.getValue(this.CTAG_xTranslate);
    }
    setTranslateX(value) {
        console.log("setTranslateX method of ControlGradient");
        this.proxy.setValue(this.CTAG_xTranslate, value);
        //this.canvas.setValue(value);
    }
    getColor() {
        return this.proxy.getValue(this.CTAG_Opacity);
    }
    getProxy() {
        return this.proxy;
    }
    setColor(value) {
        if (printClass.printStatus)
            console.log("setColor method of ControlGradient");
        this.proxy.setValue(this.CTAG_Opacity, value);
        //this.canvas.setValue(value);
    }
    getTranslateY() {
        return this.proxy.getValue(this.CTAG_yTranslate);
    }
    setTranslateY(value) {
        console.log("setTranslateY method of ControlGradient");
        this.proxy.setValue(this.CTAG_yTranslate, value);
        //this.canvas.setValue(value);
    }
    //**********************************************************************
    // Override Methods (LivePropertyListener)
    //**********************************************************************
    propertyChanged(e) {
        if (printClass.printStatus)
            console.log("propertyChanged method of controlScatterPlot");
        if (printClass.printStatus)
            console.log(e);
        var tag = e.getLiveProperty().getTag();
        if (printClass.printStatus)
            console.log(tag);
        var ve = e.getVariableEvent();
        if (tag == this.CTAG_Selection) {
            if (printClass.printStatus)
                console.log("ControlGradient Selection");
            this.gradient.setSelection(e.getLiveProperty().getVariable().getValue());
            // this.slider.setValue(90);
        }
    }
    //**********************************************************************
    // Private Methods (Graphics)
    //**********************************************************************
    describe() {
        throw new Error("Method not implemented.");
    }
    dispose() {
        throw new Error("Method not implemented.");
    }
}
//******************************************************************************
//# sourceMappingURL=ControlGradient.js.map