//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
import { Prototype } from "../LP/Prototype.js";
import { ControlProxy } from "../LP/ControlProxy.js";
import { PixelClass } from "../view/pixel.js";
import { printClass } from "../LP/printClass.js";
//******************************************************************************
// class ControlSlider
//******************************************************************************
export class ControlPixel {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor(name) {
        //**********************************************************************
        // Public Class Members (Properties)
        //**********************************************************************
        this.CTAG_VALUE = "Value";
        this.TYPE_VALUE = new Prototype(Number.prototype, this.CTAG_VALUE, 0);
        this.proxy = new ControlProxy(this);
        this.live_property = this.proxy.add(this.CTAG_VALUE, this.TYPE_VALUE, true);
        this.ControlName = name;
        this.Pixel = new PixelClass(name);
        //create the variables pproxy and ttag to be used in add event listener as we cannot use this 
        //keyword to access the current class i.e control slider inside the add event listener method.
        var pproxy = this.proxy;
        var ttag = this.CTAG_VALUE;
        document.getElementById("myValue" + name).addEventListener("input", function () { pproxy.getLiveProperty(ttag).setValue(parseInt(this.value)); });
    }
    //**********************************************************************
    // Public Methods (Properties)
    //**********************************************************************
    getValue() {
        return this.proxy.getValue(this.CTAG_VALUE);
    }
    setValue(value) {
        this.proxy.setValue(this.CTAG_VALUE, value);
        this.Pixel.setValue(value);
    }
    //**********************************************************************
    // Override Methods (ChangeListener)
    //**********************************************************************
    stateChanged(e) {
        var value = this.Pixel.getValue();
        if (value != this.getValue())
            this.setValue(value);
    }
    //**********************************************************************
    // Override Methods (LivePropertyListener)
    //**********************************************************************
    propertyChanged(e) {
        if (printClass.printStatus)
            console.log("I am in property changed method of control Pixel");
        if (printClass.printStatus)
            console.log(e);
        var tag = e.getLiveProperty().getTag();
        if (printClass.printStatus)
            console.log(tag);
        var ve = e.getVariableEvent();
        if (printClass.printStatus)
            console.log(ve);
        if (tag == this.CTAG_VALUE) {
            if (printClass.printStatus)
                console.log(e.getLiveProperty().variable.getPrototype().value);
            this.Pixel.setValue(e.getLiveProperty().getVariable().getValue());
        }
    }
    //**********************************************************************
    // Private Methods (Graphics)
    //**********************************************************************
    describe() {
        throw new Error("Method not implemented.");
    }
    dispose() {
        throw new Error("Method not implemented.");
    }
}
//******************************************************************************
//# sourceMappingURL=ControlPixel.js.map