//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
import { Prototype } from "../LP/Prototype.js";
import { ControlProxy } from "../LP/ControlProxy.js";
import { VariableEvent } from "../LP/VariableEvent.js";
import { SliderClass } from "../view/slider.js";
//import { typeOfValue } from "../index.js";
import { printClass } from "../LP/printClass.js";
//******************************************************************************
// class ControlSlider
//******************************************************************************
export class ControlSlider {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor(name, xPos, yPos) {
        //**********************************************************************
        // Public Class Members (Properties)
        //**********************************************************************
        this.CTAG_VALUE = "Value";
        this.TYPE_VALUE = new Prototype(Number.prototype, this.CTAG_VALUE, 0);
        this.proxy = new ControlProxy(this);
        //create live property
        this.live_property = this.proxy.add(this.CTAG_VALUE, this.TYPE_VALUE, true);
        if (printClass.printStatus)
            console.log(this.live_property);
        this.ControlName = name;
        this.slider = new SliderClass(name, xPos, yPos);
        if (printClass.printStatus)
            console.log(name);
        //create the variables pproxy and ttag to be used in add event listener as we cannot use this 
        //keyword to access the current class i.e control slider inside the add event listener method.
        var pproxy = this.proxy;
        var ttag = this.CTAG_VALUE;
        document.getElementById("myRange" + name).addEventListener("input", function () {
            pproxy.getLiveProperty(ttag).setValue(parseInt(this.value));
            //if(printClass.printStatus) console.log("hurray");
        });
    }
    notifyslider(e) {
        if (printClass.printStatus)
            console.log("I am in notifyslider method of controlSlider");
        //if(printClass.printStatus) console.log(this.getsupport());
        this.proxy.getLiveProperty(this.CTAG_VALUE).setVariable(e.target.value);
    }
    //**********************************************************************
    // Public Methods (Properties)
    //**********************************************************************
    getValue() {
        return this.proxy.getValue(this.CTAG_VALUE);
    }
    setValue(value) {
        this.proxy.setValue(this.CTAG_VALUE, value);
        this.slider.setValue(value);
    }
    //**********************************************************************
    // Override Methods (ChangeListener)
    //**********************************************************************
    stateChanged(e) {
        var value = this.slider.getValue();
        if (value != this.getValue())
            this.setValue(value);
    }
    //**********************************************************************
    // Override Methods (LivePropertyListener)
    //**********************************************************************
    propertyChanged(e) {
        if (printClass.printStatus)
            console.log("propertyChanged method of controlSlider");
        if (printClass.printStatus)
            console.log(e);
        var tag = e.getLiveProperty().getTag();
        if (printClass.printStatus)
            console.log(tag);
        var ve = e.getVariableEvent();
        if (printClass.printStatus)
            console.log(ve); //this value should not be null
        if (printClass.printStatus)
            console.log(VariableEvent.VALUE_CHANGED);
        if (tag == this.CTAG_VALUE) {
            if (printClass.printStatus)
                console.log("ControlSlider");
            if (printClass.printStatus)
                console.log(e.getLiveProperty().variable.getPrototype().value);
            if (printClass.printStatus)
                console.log(e.getLiveProperty().getVariable().getValue());
            this.slider.setValue(e.getLiveProperty().getVariable().getValue());
        }
    }
    //**********************************************************************
    // Private Methods (Graphics)
    //**********************************************************************
    describe() {
        throw new Error("Method not implemented.");
    }
    dispose() {
        throw new Error("Method not implemented.");
    }
}
//******************************************************************************
//# sourceMappingURL=ControlSlider.js.map