//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.

// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.

// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

import {Disposable} from "./Disposable.js"
import {LivePropertyListener} from "./LivePropertyListener.js"
import {ControlInfo} from "./ControlInfo.js"

	export interface Control extends Disposable, LivePropertyListener
	{
		//**********************************************************************
		// Members
		//**********************************************************************
	
		//**********************************************************************
		// Methods
		//**********************************************************************
	
		/**
		 * Returns a description of this control as a ControlInfo object.
		 */
			describe():ControlInfo;
	
		/**
		 * Disposes of this control. This method is called to release resources used
		 * by this control, in particular its LiveProperties.
		 */
		//void	dispose();
	}
	
	//******************************************************************************
